/*
 * ProjektTeilnehmer.java
 *
 * Created on 17. Juli 2006, 11:50
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package blima;

import aswtools.ASWTools;
import com.sun.corba.se.impl.protocol.SpecialMethod;
import java.io.StreamTokenizer;
import java.util.StringTokenizer;

/** ich lasse alles ffentlich, weil die klasse gut verpackt in BlimaProjekt lebt
 *
 * @author eeasw
 */
public class ProjektTeilnehmer
{
  
  /** Creates a new instance of ProjektTeilnehmer */
  public ProjektTeilnehmer(BlimaTeilnehmer bt)
  {
    name = bt.getName();
    eigendatei = bt.getFullFile();
    ziel = "";
    effekt = "";
    aktion = "";
    zielindex = -1;
  }
  
  /** Konstruktor aus dem "save"
   * 
   * @param s der savestring
   */
  public ProjektTeilnehmer(String s)
  {
    String ar[] = s.split(";");
    if (ar.length < 8) return;
    name = ar[0].replace("##", ";");
    eigendatei = ar[1].replace("##", ";");
    ziel = ar[2].replace("##", ";");
    effekt = ar[3].replace("##", ";");
    aktion = ar[4].replace("##", ";");
    zielVon = ar[5].replace("##", ";");
    zielindex = ASWTools.toInt(ar[6]);
    zielVonindex = ASWTools.toInt(ar[7]);
  }
  
  public String toSaveString()
  {
    StringBuffer sb = new StringBuffer();
    sb.append(name.replace(";", "##"));
    sb.append(";");
    sb.append(eigendatei.replace(";", "##"));
    sb.append(";");
    sb.append(ziel.replace(";", "##"));
    sb.append(";");
    sb.append(effekt.replace(";", "##"));
    sb.append(";");
    sb.append(aktion.replace(";", "##"));
    sb.append(";");
    sb.append(zielVon.replace(";", "##"));
    sb.append(";");
    sb.append(ASWTools.toStr(zielindex));
    sb.append(";");
    sb.append(ASWTools.toStr(zielVonindex));
    return sb.toString();
  }

  public String toString()
  {
    return java.util.ResourceBundle.getBundle("blima/BlimaText").getString("tabParticipant") + " " + name;
  }

  /** Tester, ob man deas Projekt abschlieen kann
   * 
   * @return true, wenn in effekt und aktion was steht
   */
  public boolean isDone()
  {
    return (aktion.length() > 0 && effekt.length() > 0);
  }
  public String name;
  public String eigendatei;
  public String ziel;
  public String zielVon;
  public String effekt;
  public String aktion;

  public int zielindex;
  public int zielVonindex;
}
