/*
 * TListe.java
 *
 * Created on 11. Juli 2006, 13:02
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package blima;

import java.io.File;
import java.util.Vector;
import aswtools.ASWTools;
import javax.swing.ListModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
        
/** Liste der Teilnehmer
 *
 * @author eeasw
 */
public class TListe implements ListModel
{
  /**
   * vektor der teilnehmer
   */
  Vector m_leute;
  
  /** Creates a new instance of TListe */
  public TListe()
  {
    m_ldl = new Vector();
    m_leute = new Vector();
    int n = ASWTools.toInt(BlimaConfig.getInstance().getProperty("partycount", "0"));
    for (int i = 0; i < n; i++)
    {
      String key = "party" + ASWTools.toStr(i);
      String s = BlimaConfig.getInstance().getProperty(key, "");
      if (s.length() > 0)
      {
        BlimaTeilnehmer bt = new BlimaTeilnehmer(s);
        TeilnehmerEditForm tef = new TeilnehmerEditForm(bt);
        tef.setVisible(true);
        m_leute.addElement(bt);
      }
    }
  }

  public void addElement(BlimaTeilnehmer bt)
  {
    m_leute.addElement(bt);
    ListDataEvent e = new ListDataEvent(this, ListDataEvent.INTERVAL_ADDED, m_leute.size()-1, m_leute.size()-1);
    for (Object elem : m_ldl)
    {
      ListDataListener l = (ListDataListener)elem;
      l.intervalAdded(e);
    }
  }
  
  public int getSize()
  {
    return m_leute.size();
  }

  public BlimaTeilnehmer getElementAt(int index)
  {
    return (BlimaTeilnehmer)m_leute.get(index);
  }

  /** list of the ListDataListener  */
  Vector m_ldl;
  public void addListDataListener(ListDataListener l)
  {
    m_ldl.addElement(l);
    l.contentsChanged(new ListDataEvent(this,1,0,0));
  }

  public void removeListDataListener(ListDataListener l)
  {
    m_ldl.removeElement(l);
  }  

  void removeElementAt(int k)
  {
    BlimaTeilnehmer bt = getElementAt(k);
    File f = new File(bt.getFullFile());
    f.delete();
    m_leute.remove(k);
    ListDataEvent e = new ListDataEvent(this, ListDataEvent.INTERVAL_REMOVED, k, k);
    for (Object elem : m_ldl)
    {
      ListDataListener l = (ListDataListener)elem;
      l.intervalRemoved(e);
    }
  }
}
